uses crt, graph;
type
  coord3d = array[1..4] of integer;
  coord2d = array[1..3] of integer;

const
  box : array [1..8] of coord3d = ( (-3,3,1,0), (3,3,1,0), (3,-3,1,0), (-3,-3,1,0),
        (-3,3,3,0), (3,3,3,0), (3,-3,3,0), (-3,-3,3,0) );

procedure convert(xyz : coord3d; var xy : coord2d);
begin
  xy[1]:=(xyz[1]*16) div xyz[3] + 320;
  xy[2]:=(xyz[2]*16) div xyz[3] + 240;
end;

procedure init;
var gd, gm : integer;
begin
  gd:=VGA; gm:=VGAHi;
  initgraph(gd,gm,'\BP\BGI');
  gd:=graphresult;
  if gd<>grOK then
  begin
    writeln('Error : ',grapherrormsg(gd)); halt;
  end;
end;

procedure destroy;
begin
  closegraph;
end;

procedure drawbox;
var
  proj : array[1..8] of coord2d;
  i    : byte;
begin
  for i:=1 to 8 do convert(box[i],proj[i]);
  line(proj[1,1],proj[1,2],proj[2,1],proj[2,2]);
  line(proj[2,1],proj[2,2],proj[3,1],proj[3,2]);
  line(proj[3,1],proj[3,2],proj[4,1],proj[4,2]);
  line(proj[1,1],proj[1,2],proj[4,1],proj[4,2]);
  line(proj[1,1],proj[1,2],proj[5,1],proj[5,2]);
  line(proj[2,1],proj[2,2],proj[6,1],proj[6,2]);
  line(proj[3,1],proj[3,2],proj[7,1],proj[7,2]);
  line(proj[4,1],proj[4,2],proj[8,1],proj[8,2]);
  line(proj[5,1],proj[5,2],proj[6,1],proj[6,2]);
  line(proj[6,1],proj[6,2],proj[7,1],proj[7,2]);
  line(proj[7,1],proj[7,2],proj[8,1],proj[8,2]);
  line(proj[5,1],proj[5,2],proj[8,1],proj[8,2]);
end;

procedure translation(var xyz : coord3d; trans : coord3d);
begin
  xyz[1]:=xyz[1]+trans[1];
  xyz[2]:=xyz[2]+trans[2];
  xyz[3]:=xyz[3]+trans[3];
end;

procedure show;
const trans : coord3d = (1,0,0,0);
var   i, j  : integer;
begin
  for i:=1 to 20 do
  begin
    for j:=1 to 8 do translation(box[j],trans);
    drawbox;
    delay(5);
    if i=20 then break;
    cleardevice;
  end;
end;

begin
  init;
  setcolor(11);
  show;
  readkey;
  destroy;
end.
